VERSION 5.00
Begin VB.UserControl DJClock 
   Alignable       =   -1  'True
   ClientHeight    =   525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1575
   ScaleHeight     =   525
   ScaleWidth      =   1575
   ToolboxBitmap   =   "DJClock.ctx":0000
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   600
      Top             =   45
   End
   Begin VB.Label lblChar 
      AutoSize        =   -1  'True
      Caption         =   "X"
      Height          =   195
      Index           =   1
      Left            =   180
      TabIndex        =   0
      Top             =   165
      Width           =   105
   End
End
Attribute VB_Name = "DJClock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Base 1
Enum iBorder
  [None] = 0
  [Fixed Single] = 1
End Enum
Enum TimeDate
  [Date] = 0
  [Time] = 1
  [Both] = 2
End Enum
Private m_TimeDate As TimeDate
Private m_AutoSize As Boolean
Private m_BackColor As OLE_COLOR
Private m_ForeColor As OLE_COLOR
Private m_Text As String
'Event Declarations:
Event Click(Number As Integer)
Attribute Click.VB_Description = "Event returns character string index of character clicked."
Event Timer()
Attribute Timer.VB_Description = "Event fires every time the system clock is checked."

Private Sub lblChar_Click(Index As Integer)
  RaiseEvent Click(Index)
End Sub

Public Property Get Text() As String
Attribute Text.VB_Description = "Sets/returns caption text."
  Text = m_Text
End Property

Public Property Let Text(ByVal New_text As String)
  Dim intX As Integer
  Dim intL As Integer
  Dim intC As Integer
  intC = lblChar.Count
  intL = Len(New_text)
  
  If intL > intC Then
    For intX = intC + 1 To intL
      Load lblChar(intX)
    Next
  Else
    Do While lblChar.Count > intL
      Unload lblChar(lblChar.Count)
    Loop
  End If
  For intX = 1 To intL
    lblChar(intX) = Mid(New_text, intX, 1)
  Next
  
  Call AlignChars
  m_Text = New_text
End Property

Public Property Get CtlBackColor() As OLE_COLOR
Attribute CtlBackColor.VB_Description = "Sets/returns backcolor of control."
  CtlBackColor = UserControl.BackColor
End Property

Public Property Let CtlBackColor(New_BackColor As OLE_COLOR)
  UserControl.BackColor = New_BackColor
  PropertyChanged "CtlBackColor"
End Property

Public Property Get BackColor(ByVal Number As Integer) As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color of specified digit in the text."
  BackColor = lblChar(Number).BackColor
End Property

Public Property Let BackColor(ByVal Number As Integer, _
ByVal New_BackColor As OLE_COLOR)
  lblChar(Number).BackColor() = New_BackColor
  PropertyChanged "BackColor"
End Property

Public Property Get ForeColor(ByVal Number As Integer) As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color of specified digit in the text."
  ForeColor = lblChar(Number).ForeColor
End Property

Public Property Let ForeColor(ByVal Number As Integer, _
ByVal New_ForeColor As OLE_COLOR)
  lblChar(Number).ForeColor() = New_ForeColor
  PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
  Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
  UserControl.Enabled() = New_Enabled
  If New_Enabled Then
    Timer1.Interval = 500
  Else
    Timer1.Interval = 0
  End If
  PropertyChanged "Enabled"
End Property

Public Property Get AllBackColor() As OLE_COLOR
Attribute AllBackColor.VB_Description = "Sets/returns backcolor of all digits."
  AllBackColor = m_BackColor
End Property

Public Property Let AllBackColor(ByVal New_Color As OLE_COLOR)
  Dim intX As Integer
  For intX = 1 To lblChar.Count
    lblChar(intX).BackColor = New_Color
  Next
  m_BackColor = New_Color
  PropertyChanged "AllBackColor"
End Property

Public Property Get AllForeColor() As OLE_COLOR
Attribute AllForeColor.VB_Description = "Sets/returns forecolor of all digits."
  AllForeColor = m_ForeColor
End Property

Public Property Let AllForeColor(ByVal New_Color As OLE_COLOR)
  Dim intX As Integer
  For intX = 1 To lblChar.Count
    lblChar(intX).ForeColor = New_Color
  Next
  m_ForeColor = New_Color
  PropertyChanged "AllForeColor"
End Property

Public Property Get AutoSize() As Boolean
Attribute AutoSize.VB_Description = "Determines whether control resizes to fit contents."
  AutoSize = m_AutoSize
End Property

Public Property Let AutoSize(ByVal New_Bln As Boolean)
  m_AutoSize = New_Bln
  Call Refresh
  PropertyChanged "AutoSize"
End Property

Public Property Get Font() As Font
  Set Font = lblChar(1).Font
End Property

Public Property Set Font(ByVal New_Font As Font)
Attribute Font.VB_Description = "Sets/returns font of text."
Attribute Font.VB_UserMemId = -512
  Dim intX As Integer
  For intX = 1 To lblChar.Count
    Set lblChar(intX).Font = New_Font
  Next
  Call AlignChars
  PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As iBorder
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
  BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As iBorder)
  UserControl.BorderStyle() = New_BorderStyle
  Call Refresh
  PropertyChanged "BorderStyle"
End Property

Private Sub UserControl_InitProperties()
  m_Text = Extender.Name
  With Me
    .TimeDate = Time
    .Text = m_Text
    .CtlBackColor = Ambient.BackColor
    .AllBackColor = Ambient.BackColor
    .AllForeColor = Ambient.ForeColor
    .AutoSize = True
  End With
  lblChar(1).Move 0, 0
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  m_AutoSize = PropBag.ReadProperty("AutoSize", False)
  With Me
    .TimeDate = PropBag.ReadProperty("TimeDate", Time)
    .Text = PropBag.ReadProperty("Text", Extender.Name)
    .AllForeColor = PropBag.ReadProperty("AllForeColor", Ambient.ForeColor)
    .AllBackColor = PropBag.ReadProperty("AllBackColor", Ambient.BackColor)
    Set .Font = PropBag.ReadProperty("Font", Ambient.Font)
  End With
  With UserControl
    .Enabled = PropBag.ReadProperty("Enabled", True)
    .BorderStyle = PropBag.ReadProperty("BorderStyle", None)
    .BackColor = PropBag.ReadProperty("CtlBackColor", Ambient.BackColor)
  End With
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  With PropBag
    Call .WriteProperty("TimeDate", m_TimeDate)
    Call .WriteProperty("AutoSize", m_AutoSize)
    Call .WriteProperty("AllBackColor", m_BackColor)
    Call .WriteProperty("AllForeColor", m_ForeColor)
    Call .WriteProperty("Font", lblChar(1).Font)
    Call .WriteProperty("Text", m_Text)
    Call .WriteProperty("CtlBackColor", UserControl.BackColor)
    Call .WriteProperty("Enabled", UserControl.Enabled, True)
    Call .WriteProperty("BorderStyle", UserControl.BorderStyle, None)
  End With
End Sub

Private Sub Refresh()
  Dim intB As Integer
  Dim lngX As Long
  
  If m_AutoSize Then
    intB = Me.BorderStyle * 55
    With lblChar(lblChar.Count)
      UserControl.Height = .Top + .Height + intB
      lngX = .Left + .Width
      If UserControl.Width < lngX Or .Top = 0 Then
        UserControl.Width = lngX + intB
      End If
    End With
  End If
End Sub
Private Sub ShowObject(Obj As Object, Visible As Boolean)
  With Obj
    If Visible Then
      If Not .Visible Then .Visible = True
    Else
      If .Visible Then .Visible = False
    End If
  End With
End Sub

Private Sub AlignChars()
  Dim intX As Integer
  Dim intL As Integer
  Dim intW As Integer
  Dim intT As Integer
  Dim intH As Integer
  
  lblChar(1).Move 0, 0
  For intX = 2 To lblChar.Count
    With lblChar(intX - 1)
      intL = .Left
      intW = .Width
      intT = .Top
      intH = .Height
    End With
    If lblChar(intX) = vbCr Then
      intT = intT + intH
      intL = 0
      intW = 0
      intX = intX + 1
    End If
    lblChar(intX).Move intL + intW, intT
    Call ShowObject(lblChar(intX), True)
  Next
  Call Refresh
End Sub

Private Sub Timer1_Timer()
  Call GetTime
  RaiseEvent Timer
End Sub
Private Sub GetTime()
  Dim strT As String
  Select Case m_TimeDate
    Case Time
      Me.Text = DateTime.Time
    Case Date
      Me.Text = DateTime.Date
    Case Both
      Me.Text = Now
  End Select
End Sub

Public Property Get TimeDate() As TimeDate
Attribute TimeDate.VB_Description = "Sets/gets Display style of clock."
  TimeDate = m_TimeDate
End Property

Public Property Let TimeDate(ByVal vNewValue As TimeDate)
  m_TimeDate = vNewValue
End Property
